<?php
namespace Service;



use Teknisa\Model\Financeiro\Repositories\Boletreceber;
use Util\Instance\Repository;
use Util\Utilities;

class BilletIssued {

    public function findBilletIssued($filter){
        $cdcliente = Utilities::getEnvironment()->getCurrentCdCliente();
        return Repository::getContareceber()->findBilletIssued($filter,$cdcliente);
    }

    public function findBilletDetails($nrlanctonf,$cdfilial){
        return Repository::getContareceber()->findBilletDetails($nrlanctonf,$cdfilial);
    }

    public function findProductDetails($nrlanctonf,$cdfilial){
        return Repository::getContareceber()->findProductDetails($nrlanctonf,$cdfilial);
    }

    public function printBillet($cdfilial, $nrlanbolrec, $cdreducont, $cdbanco){

        $organization = Utilities::getEnvironment()->getCurrentOrganizationId();
        $boletos = array();
        $boletos[] = array('nrorg' => $organization);
        $boletos[] = array(array('CDFILIAL' => $cdfilial, 'NRLANBOLREC' => $nrlanbolrec, 'CDREDUCONT' => $cdreducont, 'CDBANCO' => $cdbanco ));

        $result = \Service\Integration\ERPIntegration::requestEmitir($boletos);
        $birt = $result['EmitirTituloAReceber']['relatorios'][0];
        $birt['__report_name'] = $birt['RELATORIO'];
        $urlReport = \Service\Integration\ERPIntegration::requestBrit($birt['RELATORIO'],$birt);
        if($urlReport[1] == '/' || $urlReport[0] == '/'){
            $urlReport = Utilities::getErpUrl() . $urlReport;
        }
        $dataSet = array('URL_REPORT' => $urlReport);
        return $dataSet;
    }
}

