<?php
/**
 * Created by PhpStorm.
 * User: rafaelporto
 * Date: 01/03/2016
 * Time: 10:09
 */

namespace Service\Integration;

use Doctrine\ORM\EntityManager;
use Util\Utilities;
use Zeedhi\Framework\DTO\Request;


class ERPIntegration {



    public static function requestEmitir($data){
        $route = '/titulorec/emitir';
        $data = self::getDataRequestDataSet($data);
        return self::request($route,$data);
    }

    public static function requestBrit($nameBirt,$data){
        $route = '/'.$nameBirt;
        $data = self::getDataRequestRow($data);
        return self::requestBritPebbian($route,$data);
    }

    public static function requestBritPebbian($route, $data){


        list($token,$libClientId) = self::requestToken();

        $url = Utilities::getErpUrl().$route;
        $data = json_encode($data);
        $header = array();
        $header[] = 'OAuth-Token: '.$token;
        $header[] = 'OAuth-SecretId: '.$libClientId;
        $header[] = 'OAuth-KeepConnected: Yes';
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: '.strlen($data);
        $header[] = 'Expect:';

        $curl_session = curl_init();

        curl_setopt($curl_session, CURLOPT_HTTPHEADER, $header);
        curl_setopt($curl_session, CURLOPT_URL, $url);
        curl_setopt($curl_session, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl_session, CURLOPT_TIMEOUT, 86400);
        curl_setopt($curl_session, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($curl_session);
        $error = curl_error($curl_session);
        curl_close($curl_session);
        $result = json_decode($result, true);
        if (!empty($result['error'])) {
            throw new \Exception($result['error']);
        } else if (!empty($error)) {
            throw new \Exception($error);
        } else {
            $result = isset($result['messages'][0]['message']) ? $result['messages'][0]['message'] : null;
        }
        return $result;
    }


    public static function request($route, $data){


        list($token,$libClientId) = self::requestToken();

        $url = Utilities::getErpUrl().$route;
        $data = json_encode($data);
        $header = array();
        $header[] = 'OAuth-Token: '.$token;
        $header[] = 'OAuth-SecretId: '.$libClientId;
        $header[] = 'OAuth-KeepConnected: Yes';
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: '.strlen($data);
        $header[] = 'Expect:';

        $curl_session = curl_init();

        curl_setopt($curl_session, CURLOPT_HTTPHEADER, $header);
        curl_setopt($curl_session, CURLOPT_URL, $url);
        curl_setopt($curl_session, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl_session, CURLOPT_TIMEOUT, 86400);
        curl_setopt($curl_session, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($curl_session);
        $error = curl_error($curl_session);
        curl_close($curl_session);
        $result = json_decode($result, true);
        if (!empty($result['error'])) {
            throw new \Exception($result['error']);
        } else if (!empty($error)) {
            throw new \Exception($error);
        } else if (!empty($result['messages'])) {
            throw new \Exception($result['messages'][0]['message']);
        }  else {
            $result = isset($result['dataset']) ? $result['dataset'] : null;
        }
        return $result;
    }

    public static function requestToken(){
        $integration = \Teknisa\Libs\Util\Utilities::getLoginIntegration();
        $libClientId     = $integration['clientId'];
        $libClientSecret = $integration['clientSecret'];

        $data = array(
            "CLIENT_ID" => $libClientId,
            "CLIENT_SECRET" => $libClientSecret
        );

        $data = json_encode($data);
        $url = Utilities::getErpUrl().'/lib_requestToken';
        $header = array();
        $header[] = 'Content-Type: application/json';
        $header[] = 'OAuth-KeepConnected: Yes';
        $header[] = 'Content-Length: '.strlen($data);

        $curl_session = curl_init();

        curl_setopt($curl_session, CURLOPT_HTTPHEADER, $header);
        curl_setopt($curl_session, CURLOPT_URL, $url);
        curl_setopt($curl_session, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl_session, CURLOPT_RETURNTRANSFER, true);

        $result = curl_exec($curl_session);
        $error = curl_error($curl_session);

        curl_close($curl_session);

        $result = json_decode($result, true);

        $token = $result["dataset"]["token"][0];

        return array($token,$libClientId);
    }

    private static function getDataRequestDataSet($dataSet) {
        $dataSet = array(
            "requestType" => Request::TYPE_DATA_SET,
            "dataset" => $dataSet
        );

        return $dataSet;
    }

    private static function getDataRequestRow($row) {
        $dataSet = array(
            "requestType" => Request::TYPE_ROW,
            "row" => $row
        );

        return $dataSet;
    }
}