-- ================================================================================
--   Created on    :  20/05/2004
--   Programador   :  Renata Diniz
--  @C:\WIN_V4\SQL\END_CONV\ORACLE\5103_DFSSTPO.SQL
-- ================================================================================

CREATE OR REPLACE PROCEDURE CALCULA_IMPOSTO(
   P_CDPRODUTO    IN ITEMVENDA.CDPRODUTO%TYPE,
   P_CDEMPRESA    IN VENDA.CDEMPRESA%TYPE,
   P_CDFILIAL     IN VARCHAR2,
   P_CDCLIENTE    IN VENDA.CDCLIENTE%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE, /* 'T' - clculo de todos os impostos */
   P_DTVENDAINI   IN DATE,
   P_DTVENDAFIN   IN DATE,
   P_VRPREBRUTO   IN NUMBER,
   P_VRIMPOSTO    OUT NUMBER)

 AS

   V_PAISORIG      VARCHAR2(04);
   V_ESTAORIG      VARCHAR2(02);
   V_MUNIORIG      VARCHAR2(04);
   V_PAISDEST      VARCHAR2(04);
   V_ESTADEST      VARCHAR2(02);
   V_IDENDCFOP     VARCHAR2(01);
   V_IDENDEMIS     VARCHAR2(01);
   V_TAXABASECALC  NUMBER;
   V_TAXAALIQUOTA  NUMBER;
   V_BASECALCIT    NUMBER;
   V_IMPOSTOIT     NUMBER;
   V_IMPOSTOTOTAL  NUMBER;
   V_NRALIQTEMP    VARCHAR2(14);
   V_PARDEDTMP     NUMBER;
   V_PREDBCTMP     NUMBER;
   V_ALIQUTMP      NUMBER;
   V_CDGRUPOFISC   VARCHAR2(03);

BEGIN

   V_IMPOSTOTOTAL := 0;

   CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE, '', 'S', '01', V_CDGRUPOFISC);

   SELECT MAX(NVL(IDENDCFOPFIL,'I'))
   INTO V_IDENDCFOP
   FROM FILIAL
   WHERE (CDFILIAL = P_CDFILIAL);

   IF V_IDENDCFOP = 'I' THEN
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
      INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
      FROM INSCRESTAD
      WHERE CDEMPRESA  = P_CDEMPRESA AND
            CDINSCESTA = P_CDINSCESTA;
   ELSE
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
      INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
      FROM ENDEFILI
      WHERE (CDFILIAL     = P_CDFILIAL) AND
            (IDTPENDEFILI = V_IDENDCFOP);
   END IF;

   SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
   INTO V_IDENDCFOP, V_IDENDEMIS
   FROM CLIENTE
   WHERE (CDCLIENTE = P_CDCLIENTE);

   SELECT MAX(CDPAIS), MAX(SGESTADO)
   INTO V_PAISDEST, V_ESTADEST
   FROM ENDECLIE
   WHERE (CDCLIENTE    = P_CDCLIENTE) AND
         (IDTPENDECLIE = V_IDENDEMIS);

   CONSULTA_INCIDENCIA('S', P_CDEMPRESA, P_CDPRODUTO, P_CDINSCESTA, '01', P_CDFILIAL, '00000', V_CDGRUPOFISC);

   FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP,
                               IDCONSISTENT, IDIMPORECUP
                        FROM INCITEMP IT, IMPOSTO IP
                        WHERE (IT.NRINCITEMP = P_CDFILIAL||'00000') AND
                              (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                              (IP.IDPRODNOTA = 'P')           AND
                              (IP.CDIMPOSTO  = P_CDIMPOSTO OR P_CDIMPOSTO = 'T') ) LOOP

      CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', P_CDEMPRESA, P_CDPRODUTO, P_CDINSCESTA, V_PAISORIG,
                        V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, P_VRPREBRUTO, SYSDATE, P_CDFILIAL, '00000', V_CDGRUPOFISC);

      SELECT NVL(MAX(NRALIQTEMP),0), NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0)
      INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP
      FROM ALIQTEMP
      WHERE (NRALIQTEMP = P_CDFILIAL||'00000');

      V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
      V_TAXAALIQUOTA := (V_ALIQUTMP/100);
      V_BASECALCIT   := P_VRPREBRUTO * V_TAXABASECALC;
      V_IMPOSTOIT    := ((P_VRPREBRUTO * V_TAXABASECALC) * V_TAXAALIQUOTA) - V_PARDEDTMP;

      V_IMPOSTOTOTAL := V_IMPOSTOTOTAL + V_IMPOSTOIT;

      DELETE FROM ALIQTEMP
      WHERE NRALIQTEMP = P_CDFILIAL||'00000';

   END LOOP;
   
   DELETE INCITEMP
   WHERE NRINCITEMP = P_CDFILIAL||'00000';

   P_VRIMPOSTO := V_IMPOSTOTOTAL;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_IMPOSTO','4.05.113'); END;
/

