CREATE OR REPLACE PROCEDURE APROVA_PEDALTCARD
(
    P_NRPEDALTCARD NUMBER,
    P_CDOPERADOR VARCHAR2,
    P_DSRESPOSTA  VARCHAR2
)
AS
    V_CDFILIAL VARCHAR2(4);
    V_CDSERVFILI VARCHAR2(5);
    V_DTMESCARD DATE;
    V_NRCARDAPIO VARCHAR2(10);
    V_QTCLIESTICAR FLOAT;
    V_QTFUNESTICAR FLOAT;
    V_QTDOAESTICAR FLOAT;
    V_QTCOMESTICAR FLOAT;
    V_QTESTITURNO1 FLOAT;
    V_QTESTITURNO2 FLOAT;
    V_QTESTITURNO3 FLOAT;
    V_QTESTITURNO4 FLOAT;
    V_EXISTE_CARDACLI NUMBER;
    V_CARD_LIBERADO NUMBER;
    V_IDCARDDESCENTR VARCHAR2(1);
    V_CDPRATO VARCHAR2(10);
    V_CDFILAUXPRAT VARCHAR2(4);
    V_NRSEQPRATCAR NUMBER;
    V_VRPECONSCARD FLOAT;
    V_NRSEQCNFMES NUMBER;
    V_NRORDCNFMES NUMBER;
    V_CDTIPOPRAT VARCHAR2(2);
    V_CDPRATOMAT VARCHAR2(10);
    V_CDFILAUXPRATMAT VARCHAR2(4);
    V_IDPRATOESPE VARCHAR2(1);
    V_IDSITUACAO VARCHAR2(1);
BEGIN
    -- Identificar o cardpio
    BEGIN
        SELECT CDFILIAL, CDSERVFILI, DTMESCARD, IDSITUACAO
        INTO V_CDFILIAL, V_CDSERVFILI, V_DTMESCARD, V_IDSITUACAO
        FROM PEDALTCARD
        WHERE NRPEDALTCARD = P_NRPEDALTCARD;
    EXCEPTION
        WHEN OTHERS THEN
            V_CDFILIAL := NULL;
            V_CDSERVFILI := NULL;
            V_DTMESCARD := NULL;
    END;
    IF V_CDFILIAL IS NULL OR (V_IDSITUACAO <> 'E' AND  V_IDSITUACAO <> 'C' ) THEN
        RETURN;
    END IF;    
    -- Percorrer as alteraes de comensais do dia e dos turnos
    FOR C_PEDALTCARDDIA IN
    (
        SELECT CDFILIAL, NRCARDAPIO, DTCARDAPIO,
        QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
        QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4
        FROM PEDALTCARDDIA
        WHERE NRPEDALTCARD = P_NRPEDALTCARD
    ) LOOP        
        IF V_CDFILIAL <> C_PEDALTCARDDIA.CDFILIAL OR
           V_DTMESCARD <> TRUNC(C_PEDALTCARDDIA.DTCARDAPIO) THEN
            CONTINUE;
        END IF;

        -- Busca informaes atualmente no cardpio
        BEGIN
            SELECT NRCARDAPIO,
            QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
            QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4
            INTO V_NRCARDAPIO,
            V_QTCLIESTICAR, V_QTFUNESTICAR, V_QTDOAESTICAR,
            V_QTESTITURNO1, V_QTESTITURNO2, V_QTESTITURNO3, V_QTESTITURNO4
            FROM CARDADIA
            WHERE CDFILIAL = C_PEDALTCARDDIA.CDFILIAL
            AND NRCARDAPIO = C_PEDALTCARDDIA.NRCARDAPIO;
        EXCEPTION
            WHEN OTHERS THEN
                V_NRCARDAPIO := NULL;
                V_QTCLIESTICAR := NULL;
                V_QTFUNESTICAR := NULL;
                V_QTDOAESTICAR := NULL;
                V_QTESTITURNO1 := NULL;
                V_QTESTITURNO2 := NULL;
                V_QTESTITURNO3 := NULL;
                V_QTESTITURNO4 := NULL;
        END;

        -- Atualmente no permite incluir em dias que no tem cardadia
        IF V_NRCARDAPIO IS NULL THEN
            CONTINUE;
        END IF;

        IF C_PEDALTCARDDIA.QTCLIESTICAR > 0 THEN
            V_QTCLIESTICAR := C_PEDALTCARDDIA.QTCLIESTICAR;
        END IF;
        IF C_PEDALTCARDDIA.QTFUNESTICAR > 0 THEN
            V_QTFUNESTICAR := C_PEDALTCARDDIA.QTFUNESTICAR;
        END IF;
        IF C_PEDALTCARDDIA.QTDOAESTICAR > 0 THEN
            V_QTDOAESTICAR := C_PEDALTCARDDIA.QTDOAESTICAR;
        END IF;
        V_QTCOMESTICAR := NVL(V_QTCLIESTICAR, 0) + NVL(V_QTFUNESTICAR, 0) + NVL(V_QTDOAESTICAR, 0);
        IF C_PEDALTCARDDIA.QTESTITURNO1 > 0 THEN
            V_QTESTITURNO1 := C_PEDALTCARDDIA.QTESTITURNO1;
        END IF;
        IF C_PEDALTCARDDIA.QTESTITURNO2 > 0 THEN
            V_QTESTITURNO2 := C_PEDALTCARDDIA.QTESTITURNO2;
        END IF;
        IF C_PEDALTCARDDIA.QTESTITURNO3 > 0 THEN
            V_QTESTITURNO3 := C_PEDALTCARDDIA.QTESTITURNO3;
        END IF;
        IF C_PEDALTCARDDIA.QTESTITURNO4 > 0 THEN
            V_QTESTITURNO4 := C_PEDALTCARDDIA.QTESTITURNO4;
        END IF;

        -- Atualizar os comensais do dia e turnos de acordo com o pedido
        UPDATE CARDADIA
           SET QTCLIESTICAR = V_QTCLIESTICAR,
               QTFUNESTICAR = V_QTFUNESTICAR,
               QTDOAESTICAR = V_QTDOAESTICAR,
               QTCOMESTICAR = V_QTCOMESTICAR,
               QTESTITURNO1 = V_QTESTITURNO1,
               QTESTITURNO2 = V_QTESTITURNO2,
               QTESTITURNO3 = V_QTESTITURNO3,
               QTESTITURNO4 = V_QTESTITURNO4,
               DTULTATU = SYSDATE,
               CDOPERULTATU = P_CDOPERADOR
         WHERE CDFILIAL = V_CDFILIAL
           AND NRCARDAPIO = V_NRCARDAPIO;
    END LOOP;
       
    -- Percorrer as alteraes dos pontos de entrega
    FOR C_PEDALTCARDCLI IN
    (
        SELECT P.CDFILIAL, P.NRCARDAPIO, P.CDCLIENTE,
        P.CDDESTFILI, P.QTCOMESTICLI
        FROM PEDALTCARDCLI P
        WHERE NRPEDALTCARD = P_NRPEDALTCARD
        AND EXISTS (
            SELECT 1 FROM DESTSRVCLI D 
            WHERE D.CDFILIAL = P.CDFILIAL AND
            D.CDSERVFILI = V_CDSERVFILI AND
            D.CDCLIENTE = P.CDCLIENTE AND
            D.CDDESTFILI = P.CDDESTFILI
        )
    ) LOOP
        -- Atualizar os pontos de entrega de acordo com o pedido. Inserir os pontos de entrega que no existir na CARDACLI
        SELECT COUNT(1)
        INTO V_EXISTE_CARDACLI
        FROM CARDACLI
        WHERE CDFILIAL = C_PEDALTCARDCLI.CDFILIAL
        AND NRCARDAPIO = C_PEDALTCARDCLI.NRCARDAPIO
        AND CDCLIENTE = C_PEDALTCARDCLI.CDCLIENTE
        AND CDDESTFILI = C_PEDALTCARDCLI.CDDESTFILI;
        
        IF V_EXISTE_CARDACLI > 0 THEN
            UPDATE CARDACLI
            SET QTCOMESTICLI = C_PEDALTCARDCLI.QTCOMESTICLI
            WHERE CDFILIAL = C_PEDALTCARDCLI.CDFILIAL
            AND NRCARDAPIO = C_PEDALTCARDCLI.NRCARDAPIO
            AND CDCLIENTE = C_PEDALTCARDCLI.CDCLIENTE
            AND CDDESTFILI = C_PEDALTCARDCLI.CDDESTFILI;
        ELSE
            INSERT INTO CARDACLI
            (
                CDFILIAL, NRCARDAPIO, CDCLIENTE, 
                CDDESTFILI, QTCOMESTICLI,
                DTULTATU, CDOPERULTATU
            )
            VALUES
            (
                C_PEDALTCARDCLI.CDFILIAL, C_PEDALTCARDCLI.NRCARDAPIO, C_PEDALTCARDCLI.CDCLIENTE,
                C_PEDALTCARDCLI.CDDESTFILI, C_PEDALTCARDCLI.QTCOMESTICLI,
                SYSDATE, P_CDOPERADOR
            );
        END IF;
    END LOOP;

    -- Verifica se o servio do cardpio  descentralizado
    SELECT MAX(IDCARDDESCENTR)
    INTO V_IDCARDDESCENTR
    FROM SERVICO
    WHERE CDFILIAL = V_CDFILIAL AND CDSERVFILI = V_CDSERVFILI;

    -- Verifica se o cardpio est liberado
    SELECT COUNT(1)
    INTO V_CARD_LIBERADO
    FROM CTRLAPROVCARD CTRL
    WHERE CDFILIAL = V_CDFILIAL
    AND CDSERVFILI = V_CDSERVFILI
    AND DTMESCARDAPROV = V_DTMESCARD
    AND DTLIBECARDMATR IS NOT NULL;

    -- Percorrer as alteraes da composio do cardpio
    FOR C_PEDALTCARDCOMP IN
    (
        SELECT P.CDFILIAL, P.NRCARDAPIO, P.NRSEQPRATCAR,
        P.CDFILAUXPRAT, P.CDPRATO, P.VRPECONSCARD
        FROM PEDALTCARDCOMP P
        WHERE P.NRPEDALTCARD = P_NRPEDALTCARD
        AND EXISTS (SELECT 1 FROM CARDADIA CD WHERE CD.CDFILIAL = P.CDFILIAL AND CD.NRCARDAPIO = P.NRCARDAPIO)
        AND EXISTS (
            SELECT 1 FROM CARDADIA CD INNER JOIN CNFCAMES CNF 
            ON CNF.CDFILIAL = CD.CDFILIAL AND CNF.CDSERVFILI = CD.CDSERVFILI AND CNF.DTREFECNFMES = CD.DTMESCARD
            WHERE CD.CDFILIAL = P.CDFILIAL
              AND CD.NRCARDAPIO = P.NRCARDAPIO
              AND CNF.NRSEQCNFMES = P.NRSEQPRATCAR
        )
    ) LOOP
        -- Verifica se existe composio para o dia e coluna
        BEGIN
            SELECT NRSEQPRATCAR, CDPRATO, CDFILAUXPRAT,
            VRPECONSCARD, CDPRATOMAT, CDFILAUXPRATMAT
            INTO V_NRSEQPRATCAR, V_CDPRATO, V_CDFILAUXPRAT,
            V_VRPECONSCARD, V_CDPRATOMAT, V_CDFILAUXPRATMAT
            FROM COMPCARD
            WHERE CDFILIAL = C_PEDALTCARDCOMP.CDFILIAL
            AND NRCARDAPIO = C_PEDALTCARDCOMP.NRCARDAPIO
            AND NRSEQPRATCAR = C_PEDALTCARDCOMP.NRSEQPRATCAR;
        EXCEPTION
            WHEN OTHERS THEN
                V_NRSEQPRATCAR := NULL;
                V_CDPRATO := NULL;
                V_CDFILAUXPRAT := NULL;
                V_VRPECONSCARD := NULL;
                V_CDPRATOMAT := NULL;
                V_CDFILAUXPRATMAT := NULL;
        END;
        -- Atualiza a composio
        IF V_NRSEQPRATCAR IS NOT NULL THEN
            IF C_PEDALTCARDCOMP.CDFILAUXPRAT IS NOT NULL THEN
                V_CDFILAUXPRAT := C_PEDALTCARDCOMP.CDFILAUXPRAT;
                V_CDPRATO := C_PEDALTCARDCOMP.CDPRATO;
            END IF;

            -- Se cardpio j liberado pela matriz, preenche o prato original
            IF V_IDCARDDESCENTR = 'S' AND V_CARD_LIBERADO > 0 AND V_CDPRATOMAT IS NULL THEN
                V_CDPRATOMAT := V_CDPRATO;
                V_CDFILAUXPRATMAT := V_CDFILAUXPRAT;
            END IF;

            IF C_PEDALTCARDCOMP.VRPECONSCARD > 0 THEN
                V_VRPECONSCARD := C_PEDALTCARDCOMP.VRPECONSCARD;
            END IF;
            
            UPDATE COMPCARD
            SET CDFILAUXPRAT = V_CDFILAUXPRAT,
            CDPRATO = V_CDPRATO,
            CDPRATOMAT = V_CDPRATOMAT,
            CDFILAUXPRATMAT = V_CDFILAUXPRATMAT, 
            VRPECONSCARD = V_VRPECONSCARD,
            DTULTATU = SYSDATE,
            CDOPERULTATU = P_CDOPERADOR
            WHERE CDFILIAL = C_PEDALTCARDCOMP.CDFILIAL
            AND NRCARDAPIO = C_PEDALTCARDCOMP.NRCARDAPIO
            AND NRSEQPRATCAR = C_PEDALTCARDCOMP.NRSEQPRATCAR;
        ELSE
            SELECT NRSEQCNFMES,  NRORDCNFMES, CDTIPOPRAT
              INTO V_NRSEQCNFMES,  V_NRORDCNFMES, V_CDTIPOPRAT
              FROM CNFCAMES
             WHERE CDFILIAL = V_CDFILIAL
               AND CDSERVFILI = V_CDSERVFILI
               AND DTREFECNFMES = V_DTMESCARD
               AND NRSEQCNFMES = C_PEDALTCARDCOMP.NRSEQPRATCAR;
            -- Se a coluna no existir, no segue com a operao. Se os dados da composio no estiverem preenchidos, tambm no
            IF V_NRSEQCNFMES IS NULL OR
               (C_PEDALTCARDCOMP.CDPRATO IS NULL OR C_PEDALTCARDCOMP.VRPECONSCARD IS NULL or C_PEDALTCARDCOMP.VRPECONSCARD <= 0) THEN
                CONTINUE;
            END IF;
            V_IDPRATOESPE := 'N';
            -- Se o cardpio j est liberado, insere na COMPCARDDEL para dizer que a matriz liberou sem aquele prato 
            IF V_IDCARDDESCENTR = 'S' AND V_CARD_LIBERADO > 0 THEN
                V_IDPRATOESPE := 'S';
            END IF;
            -- Insere a composio
            INSERT INTO COMPCARD
            (CDFILIAL, NRCARDAPIO, NRSEQPRATCAR,
            NRORDPRATCAR, CDTIPOPRAT,CDFILAUXPRAT,
            CDPRATO, VRPECONSCARD, IDPRATOESPE,
            DTINCLUSAO, DTULTATU,
            CDOPERINCLUSAO, CDOPERULTATU)
            VALUES
            (C_PEDALTCARDCOMP.CDFILIAL, C_PEDALTCARDCOMP.NRCARDAPIO, C_PEDALTCARDCOMP.NRSEQPRATCAR,
            V_NRORDCNFMES, V_CDTIPOPRAT, C_PEDALTCARDCOMP.CDFILAUXPRAT,
            C_PEDALTCARDCOMP.CDPRATO, C_PEDALTCARDCOMP.VRPECONSCARD, V_IDPRATOESPE,
            SYSDATE, SYSDATE,
            P_CDOPERADOR, P_CDOPERADOR);
        END IF;
    END LOOP;

    -- Atualiza pedido de alterao do cardpio, sinalizando o aprovador e mudando o status
    UPDATE PEDALTCARD SET
    DTAPROVREPR = SYSDATE,
    CDOPERAPROVREPR = P_CDOPERADOR,
    IDSITUACAO = 'A',
    DSRESPOSTA = P_DSRESPOSTA,
    DTULTATU = SYSDATE,
    DTINCLUSAO = SYSDATE
    WHERE NRPEDALTCARD = P_NRPEDALTCARD;
END;
/